

FUNCTION DBF2MapiFind( cDBFCreDate, dDBFDate, cDBFtime, nMinute )
LOCAL i                  := 0
LOCAL iMax               := 0
LOCAL nFind              := 0
LOCAL oAppointment, oItem
LOCAL cFilter
LOCAL currentAppointment
LOCAL cStart
LOCAL cEnd
LOCAL bSaveError
LOCAL oError
LOCAL cStringStart
LOCAL nTimeStart
LOCAL dDate
LOCAL cTime
LOCAL OldDate


   IF InitMAPI()

      dDate := STOD( SUBSTR( cDBFCreDate, 1, 8 ) )
      cTime := SUBSTR( cDBFCreDate, 9, 2 ) + ":" + ;
                       SUBSTR( cDBFCreDate, 11, 2 ) + ":" + ;
                       SUBSTR( cDBFCreDate, 13, 2 )

      cStart := DTOC( dDate ) + " " + SUBSTR( cTime, 1, 5 )
      // add 2 Minutes
      nTimeStart := XF_HMS2SEC( cTime ) + ( 2 * 60 )
      IF nTimeStart >= 86400
         nTimeStart -= 86400
         cEnd := DTOC( dDate + 1 ) + " " + SUBSTR( XF_SEC2HMS( nTimeStart ), 1, 5 )
      ELSE
         cEnd := DTOC( dDate ) + " " + SUBSTR( XF_SEC2HMS( nTimeStart ), 1, 5 )
      ENDIF

      cFilter := "[CreationTime] >='" + cStart + "' and [CreationTime] <= '" + cEnd + "'"

      bSaveError := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )
      BEGIN SEQUENCE
         oAppointment := oNameSpace:getDefaultFolder( olFolderCalendar ) :Items
      RECOVER USING oError
         ERRORBLOCK( bSaveError )
         oAppointment := NIL
      END SEQUENCE
      ERRORBLOCK( bSaveError )
      IF NIL = oAppointment
         MsgInfo( "can not get Items" )
         ExitMAPI()
         RETURN .F.
      ENDIF

      bSaveError := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )
      BEGIN SEQUENCE
         currentAppointment := oAppointment:Restrict( cFilter )
      RECOVER USING oError
         ERRORBLOCK( bSaveError )
         MsgInfo( cFilter + " not found !" )
         ExitMAPI()
         RETURN .F.
      END SEQUENCE
      ERRORBLOCK( bSaveError )

      iMax := currentAppointment:count()
      IF NIL = iMax
         MsgInfo( cFilter + " not found iMax = NIL" )
         ExitMAPI()
         RETURN .F.
      ENDIF
      IF iMax = 0
         MsgInfo( cFilter + " not found iMax = 0" )
         ExitMAPI()
         RETURN .F.
      ELSE
         //  MsgInfo( STR(iMax)+cFilter )
      ENDIF

      //  bSaveError := ERRORBLOCK( { |oError| MyErrorHandler(oError) } )

      FOR i := 1 TO iMax
         oItem := currentAppointment:item( i )

         // will work
         //
         cStringStart := Read_CreationTime( oItem, .F. )

         // compare if it match +-3 Seconds
         //
         IF SUBSTR( cStringStart, 1, 14 ) >= SUBSTR( LTRIM( STR( ROUND( VAL( cDBFCreDate ), 0 ) ) ), 1, 14 ) .OR. ;
            SUBSTR( cStringStart, 1, 14 ) <= SUBSTR( LTRIM( STR( ROUND( VAL( cDBFCreDate ) + 3, 0 ) ) ), 1, 14 )
            oItem:Start := hb_SToT( DTOS( dDBFDate ) + StripTime( cDBFtime ) )
            oItem:Duration := nMinute                                 //-1
            oItem:save()

            Read_LastModificationTime( oItem )

            nFind ++
            EXIT
         ELSE
            //  MsgInfo( cStringStart + " <> " + LTRIM( STR( ROUND( VAL( cDBFCreDate ), 0 ) ) ) )
         ENDIF
      NEXT

      //  ERRORBLOCK( bSaveError )

      IF nFind = 0
         MsgInfo( "Error no Item found" )
      ENDIF

      ExitMAPI()
   ENDIF

RETURN .T.


FUNCTION InitMAPI()
LOCAL lRet       := .F.
LOCAL bSaveError
LOCAL oError

   bSaveError := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )
   BEGIN SEQUENCE
      oOutlook := CreateObject( "Outlook.Application" )
      lRet := .T.
   RECOVER
   END SEQUENCE
   ERRORBLOCK( bSaveError )
   IF EMPTY( oOutLook )
      msgInfo( "Outlook not installed !", "Error CreateObject()" )
      RETURN lRet
   ENDIF

   bSaveError := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )
   BEGIN SEQUENCE
      oNameSpace := oOutlook:GetNamespace( "MAPI" )
      lRet := .T.
   RECOVER
   END SEQUENCE
   ERRORBLOCK( bSaveError )
   IF EMPTY( oNameSpace )
      msgInfo( "can't get Namespace MAPI", "Error MAPI" )
      ExitMAPI()
      RETURN lRet
   ENDIF
RETURN lRet

FUNCTION ExitMAPI()
LOCAL lRet       := .F.
LOCAL bSaveError
LOCAL oError

   bSaveError := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )
   BEGIN SEQUENCE
      oNameSpace := NIL
      oOutlook:Quit()
      oOutlook := NIL
      lRet := .T.
   RECOVER USING oError
   END SEQUENCE
   ERRORBLOCK( bSaveError )
RETURN lRet


STATIC FUNCTION Read_CreationTime( oItem, lReplace )
LOCAL oError
LOCAL cStringStart := ""
LOCAL cDateStart
LOCAL cTimeStart
LOCAL bSaveError   := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )

   DEFAULT lReplace TO .T.

   BEGIN SEQUENCE
      //  MUST !!! else "corrupt" !
      cStringStart := hb_TToC( oItem:CreationTime )

      cDateStart := SUBSTR( cStringStart, 1, 10 )
      cTimeStart := SUBSTR( cStringStart, 12, 12 )                    // YYYY.MM.DDHHMMSS

      cStringStart := DTOS( CTOD( cDateStart ) ) + StripTime( cTimeStart )

      IF lReplace = .T.
         REPLACE OUTLOOK->CREDATE WITH cStringStart
      ENDIF
   RECOVER USING oError
   END SEQUENCE
   ERRORBLOCK( bSaveError )
RETURN cStringStart


STATIC FUNCTION Read_LastModificationTime( oItem, lReplace )
LOCAL oError
LOCAL cStringStart := ""
LOCAL cDateStart
LOCAL cTimeStart
LOCAL bSaveError   := ERRORBLOCK( { | oError | MyErrorHandler( oError ) } )

   DEFAULT lReplace TO .T.

   BEGIN SEQUENCE
      //  MUST !!! else "corrupt" !
      cStringStart := hb_TToC( oItem:LastModificationTime )

      cDateStart := SUBSTR( cStringStart, 1, 10 )
      cTimeStart := SUBSTR( cStringStart, 12, 12 )                    // YYYY.MM.DDHHMMSS

      cStringStart := DTOS( CTOD( cDateStart ) ) + StripTime( cTimeStart )

      IF lReplace = .T.
         REPLACE OUTLOOK->LASTDATE WITH cStringStart
      ENDIF
   RECOVER USING oError
   END SEQUENCE
   ERRORBLOCK( bSaveError )
RETURN cStringStart

//